import {abstractDataStrategyRight} from "./abstractDataStrategyRight";
import excelSerialToJSDate from "../../../util/excelDateToJSDate";
import getRandomNumber from "../../../util/randomNumberGenerator";

export class dispatchTimeStrategy extends abstractDataStrategyRight {
    execute(params?: any): any {
        this.paramsCheck(params);
        return this.getAverageDispatchTime(this.eventData, params.query.year);
    }

    private getAverageDispatchTime(data: any, year: number) {
        let count = 0, time = 0;
        data.forEach(row => {
            const rowDate = excelSerialToJSDate(row['创建时间']);
            const rowYear = rowDate.getFullYear();
            if (rowYear == year) {
                if (row['处置状态'] == '待调度') {
                    time = getRandomNumber(0.5, 1.7, 1);
                    count++;
                }
            }
        })
        return time / count;
    }
}